#include <bits/stdc++.h>

const int MAX_N = 1e6;

std::vector<int> len[MAX_N];

int main () {

    int n, m;
    std::cin>>n>>m;

    for( int i=0 ; i<m ; i++ ){
        int a, b;
        std::cin>>a>>b;
        a--; b--;
        len[a].push_back(i);
        len[b].push_back(i);
    }
    bool li = true;
    for( int i=0 ; i<n ; i++ )
        if( len[i].size() == 1 ) li = false;

    if( !li )std::cout<<m/2<<"\n";
    else std::cout<<m/2-1<<"\n";

    return 0;
}
